;-------------------- Welcome-to ------------------------;
; [$UPD1.5], $pirit's Universal Polymorphic Device v1.5 ;
;           (C)1995-1996 by Nigh$piri		 ;
;--------------------------------------------------------;
; Must compile with:					 ;
;  tasm $upddemo.asm /m					 ;
;  tlink $upddemo.obj $upd10.obj, $upddemo.com /x /t	 ;
; or use makedemo.bat for rapidly do this		 ;
;--------------------------------------------------------;

; Demo for [$UPD1.5] engine. It will generate 20 (or another count)
; tiny polymorph-encoded progs

.MODEL TINY
JUMPS
.CODE

	org	100h
	extrn	$UPD:near	; Must declare $UPD to external module
	extrn	$UPD_Top:near	; First byte address after $UPD-engine

Generations_Cnt	equ	20	; 20 generations (not above 255)
Crypt_Length	equ	EndOfCrypt-Offset Tiny_Proc
EOF		equ	$UPD_Top
CF		equ	0dh,0ah

Start:
	cld
	lea	si,Hi_Msg	; Show our copyrights
	call	Show_String

	xor	cx,cx
	mov	cl,Generations_Cnt

Creet_Next:
	push	cx

	lea	dx,File_Name	; Make encrypted file
	mov	ah,3ch
	xor	cx,cx
	int	21h
	xchg	ax,bx

	lea	si,Tiny_Proc	; ds:[si]=coding data
	lea	di,EOF		; es:[di]=buffer for encoded data
	mov	cx,Crypt_Length	; cx=coding data length
	call	$UPD		; Make polymorphic copy of Tiny_Prog

	mov	ah,40h		; cx=size of encoded date
	lea	dx,EOF
	int	21h

	mov	ah,3eh		; Close file
	int	21h

	mov	ax,word ptr [File_Name+5] ; File number
	call	IncreaseByte
	cmp	ah,'0'
	jne	No_Overflow

	xchg	ah,al
	call	IncreaseByte
	xchg	ah,al

No_Overflow:
	mov	word ptr [File_Name+5],ax

	pop	cx
	loop	Creet_Next

	int	20h

File_Name	db	'test_00.com',0
Hi_Msg		db	'[$UPD1.5], $pirit''s Universal Polymorphic Device '
		db	'v1.5 (demo)',CF
		db	'(C)1995-1996 by Nigh$piri',CF,CF
		db	'Generating 20 small polymorph-encrypted programs ...'
		db	CF,0

; Procedure increase string number 'x' on 1 byte
; Entry: ah=_STRING_ number
; Return: ah='0' if overflow

IncreaseByte	proc	near

	cmp	ah,'9'
	jb	Increase
	je	Last_Number
	cmp	ah,'F'
	jb	Increase
	mov	ah,'0'
	retn

Last_Number:
	mov	ah,'@'
Increase:
	inc	ah
	retn

IncreaseByte	endp

; Coding routine. Here you can put virii copy, for example ;)

Tiny_Proc	proc	near

	cld
	call	$+3
	pop	bx
	sub	bx,Offset $-1

	lea	si,[bx+Demo_Hi_Msg]
	call	Show_String

	int	20h

Demo_Hi_Msg	db	'This program was generated with [$UPD1.5] demo',CF
		db	'($pirit''s Universal Polymorphic Device v1.5)',CF
		db	'(C)1995-1996 by Nigh$piri',CF,0

Tiny_Proc	endp

; Procedure shows ASCIIZ-string at ds:[si]
; Return: ax,dx,si=?

Show_String	proc	near

	mov	ah,2h

Repeat_Show_String:
	lodsb
	test	al,al
	jz	EOS
	mov	dl,al
	int	21h
	jmp	Repeat_Show_String

EOS:
	retn

Show_String	endp

EndOfCrypt	=	$

	end	Start
